#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"
#include "Maths.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Lissajous 3", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    int centerX = SCREEN_WIDTH / 2;
    int centerY = SCREEN_HEIGHT/ 2;
    int radius = 200;

    for (int i = 0; i < 360; i++)
    {
        float angle = DEG_TO_RAD(i);
        int x = centerX + radius * cos(angle);
        int y = centerY + radius * sin(3.0 * angle);

        Color c;
        c.r = 255;
        c.g = 128 + 127 * cos(angle);
        c.b = 0;
        gfx.line(x, y, x, centerY, c);

        gfx.render();
        sys.wait(20);
    }

    // wait until we quit
    while (sys.isQuitRequested() == false)
    {
        gfx.render();
        sys.wait(20);
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
